# The Trinity Ethereum Client

[![Join the chat at https://gitter.im/ethereum/trinity](https://badges.gitter.im/ethereum/trinity.svg)](https://gitter.im/ethereum/trinity)
[![CircleCI](https://circleci.com/gh/ethereum/trinity/tree/master.svg?style=shield)](https://circleci.com/gh/ethereum/trinity/tree/master)
[![Documentation Status](https://readthedocs.org/projects/trinity-client/badge/?version=latest)](https://trinity-client.readthedocs.io/en/latest/?badge=latest)

Trinity is a client for the Ethereum protocol including the existing 1.0 chain as well as emerging support for the upcoming Ethereum 2.0 / Serenity spec. For the offical website, visit https://trinity.ethereum.org/

### Goals

- provide a reference implementation for an Ethereum 1.0 node (alpha)

- support "full" and "light" modes

- fully support mainnet as well as several testnets

- provide a reference implementation of an Ethereum 2.0 / Serenity beacon node (pre-alpha)

- provide a reference implementation of an Ethereum 2.0 / Serenity validator node (pre-alpha)


## Quickstart

[Get started in 5 minutes](https://trinity-client.readthedocs.io/en/latest/quickstart.html)

## Documentation

Check out the [documentation on our official website](https://trinity-client.readthedocs.io/en/latest/)

## Want to help?

Want to file a bug, contribute some code, or improve documentation? Excellent! Read up on our
guidelines for [contributing](https://trinity-client.readthedocs.io/en/latest/contributing.html) and then check out one of our issues that are labeled [Good First Issue](https://github.com/ethereum/trinity/issues?q=is%3Aissue+is%3Aopen+label%3A%22Good+First+Issue%22).
